package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.AbstractDataTransport;
import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.query.SubQuery;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.armas.parametros.util.EstadosSolicitudBPM;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.parmas.soli.TarmSolicitud;

/**
 * Clase controladora del bean TarmSolicitud.
 *
 * @version 2.1
 */
@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class SolicitudArmasBPMController extends AbstractController<TarmSolicitud> {

    public SolicitudArmasBPMController() throws Exception {
        super(TarmSolicitud.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            recperpage = 15; // Cambiar al # reg a mirar.
            lrecord = new ArrayList<>();
//            beanalias = "SOLICITUDBPM";
//            listaEstadoSolicitud= new ArrayList<EstadosSolicitudBPM>();
            this.create();
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Crea una instancia de TgeneTransactionProcess y marca el registro como
     * nuevo.
     *
     * @throws Exception
     */
    @Override
    public void create() throws Exception {
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
//        	listaEstadoSolicitud = new ArrayList<>();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setMultirecord(false);
            //nombre
            SubQuery snombre = new SubQuery("TcustPersonDetail", "name", "nombre", "i.pk.personcode = t.personcode and  i.pk.dateto=(select max(dt.pk.dateto) from TcustPersonDetail dt where dt.pk.personcode=t.personcode)");
            SubQuery snumerodocumento = new SubQuery("TcustPersonDetail", "identification", "identification", "i.pk.personcode = t.personcode and  i.pk.dateto=(select max(dt.pk.dateto) from TcustPersonDetail dt where dt.pk.personcode=t.personcode)");
            SubQuery identificationcatalog = new SubQuery("TcustPersonDetail", "identificationcatalog", "identificationcatalog", "i.pk.personcode = t.personcode and  i.pk.dateto=(select max(dt.pk.dateto) from TcustPersonDetail dt where dt.pk.personcode=t.personcode)");
            SubQuery identificationcatalogcode = new SubQuery("TcustPersonDetail", "identificationcatalogcode", "identificationcatalogcode", "i.pk.personcode = t.personcode and  i.pk.dateto=(select max(dt.pk.dateto) from TcustPersonDetail dt where dt.pk.personcode=t.personcode)");
            //tramite
//			TarmTramite
            SubQuery codigoTramite = new SubQuery("TarmTramite", "pk", "pk", "i.pk = t.ctramite");
            SubQuery tramitetipoautorizacion = new SubQuery("TarmTramite", "tipoautorizacion", "tipoautorizacion", "i.pk = t.ctramite");
            SubQuery tramitetipoautorizacioncode = new SubQuery("TarmTramite", "tipoautorizacioncodigo", "tipoautorizacioncodigo", "i.pk = t.ctramite");
            SubQuery tramitecategoria = new SubQuery("TarmTramite", "categoria", "categoria", "i.pk = t.ctramite");
            SubQuery tramitecategoriacodigo = new SubQuery("TarmTramite", "categoriacodigo", "categoriacodigo", "i.pk = t.ctramite");
            SubQuery tramiteusoactividad = new SubQuery("TarmTramite", "usoactividad", "usoactividad", "i.pk = t.ctramite");
            SubQuery tramiteusoactividadcodigo = new SubQuery("TarmTramite", "usoactividadcodigo", "usoactividadcodigo", "i.pk = t.ctramite");
            //estado
            SubQuery estado = new SubQuery("TgeneCatalogDetail", "description", "estadoSolicitud", "i.pk.catalog=t.estado and i.pk.catalogcode=t.estadocodigo");
            dto.addSubQuery(estado);

            dto.addSubQuery(snumerodocumento);
            dto.addSubQuery(snombre);
            dto.addSubQuery(identificationcatalog);
            dto.addSubQuery(identificationcatalogcode);

            dto.addSubQuery(codigoTramite);
            dto.addSubQuery(tramitetipoautorizacion);
            dto.addSubQuery(tramitetipoautorizacioncode);
            dto.addSubQuery(tramitecategoria);
            dto.addSubQuery(tramitecategoriacodigo);
            dto.addSubQuery(tramiteusoactividad);
            dto.addSubQuery(tramiteusoactividadcodigo);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(beanalias, dto); // permite adicionar mas de una tabla.

            Request request = callerhelper.getRequest();
            request.setQueryTables(mtables);
//    		request.put("queryalias", "ESTADOSSOLICITUDBPMQUERY");
//    		request.put("codigosolicitudbpm", this.getMfilters().get("numerosolicitud"));

            Response resp = callerhelper.executeQuery(request);
//            if(resp.get("LISTASESTADOSOLICITUDBPM")!=null){
//                System.out.println("------------"+resp.get("LISTASESTADOSOLICITUDBPM").toString());
//            	List<Object[]> listaEstadosSolicitud = (List<Object[]>)resp.get("LISTASESTADOSOLICITUDBPM");
//            	for (Object[] item : listaEstadosSolicitud) {
//            		EstadosSolicitudBPM estados = new EstadosSolicitudBPM();
//            		estados.setActividad(item[0]!=null?item[0].toString():"");
//            		estados.setUsuarioasignado(item[1]!=null?item[1].toString():"");
//            		estados.setGrupoasignado(item[2]!=null?item[2].toString():"");
//            		estados.setEstado(item[3]!=null?item[3].toString():"");
//            		estados.setFechacreacion(item[4]!=null?(Date)item[4]:null);
//            		estados.setFechainicio(item[5]!=null?(Date)item[5]:null);
//            		estados.setFechacompleta(item[6]!=null?(Date)item[6]:null);
//            		listaEstadoSolicitud.add(estados);
//				}
//            }

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                lrecord = new ArrayList<TarmSolicitud>();
                MessageHelper.setMessageError(resp);
            } else {
                record = (TarmSolicitud) resp.get(beanalias);
                super.postQuery((AbstractDataTransport) resp.get(beanalias));
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
    }

//	public List<EstadosSolicitudBPM> getListaEstadoSolicitud() {
//		return listaEstadoSolicitud;
//	}
//
//	public void setListaEstadoSolicitud(
//			List<EstadosSolicitudBPM> listaEstadoSolicitud) {
//		this.listaEstadoSolicitud = listaEstadoSolicitud;
//	}
}
